dart_library.library('parse_util', null, /* Imports */[
  "dart/_runtime",
  'dart/core'
], /* Lazy imports */[
], function(exports, dart, core) {
  'use strict';
  let dartx = dart.dartx;
  class ParseLocation extends core.Object {
    ParseLocation(file, offset, line, col) {
      this.file = file;
      this.offset = offset;
      this.line = line;
      this.col = col;
    }
    toString() {
      return `${this.file.url}@${this.line}:${this.col}`;
    }
  }
  dart.setSignature(ParseLocation, {
    constructors: () => ({ParseLocation: [ParseLocation, [ParseSourceFile, core.num, core.num, core.num]]})
  });
  class ParseSourceFile extends core.Object {
    ParseSourceFile(content, url) {
      this.content = content;
      this.url = url;
    }
  }
  dart.setSignature(ParseSourceFile, {
    constructors: () => ({ParseSourceFile: [ParseSourceFile, [core.String, core.String]]})
  });
  class ParseError extends core.Object {
    ParseError(location, msg) {
      this.location = location;
      this.msg = msg;
    }
    toString() {
      let source = this.location.file.content;
      let ctxStart = this.location.offset;
      if (dart.notNull(ctxStart) > dart.notNull(source[dartx.length]) - 1) {
        ctxStart = dart.notNull(source[dartx.length]) - 1;
      }
      let ctxEnd = ctxStart;
      let ctxLen = 0;
      let ctxLines = 0;
      while (dart.notNull(ctxLen) < 100 && dart.notNull(ctxStart) > 0) {
        ctxStart = dart.notNull(ctxStart) - 1;
        ctxLen = dart.notNull(ctxLen) + 1;
        if (source[dartx.get](dart.asInt(ctxStart)) == "\n") {
          if ((ctxLines = dart.notNull(ctxLines) + 1) == 3) {
            break;
          }
        }
      }
      ctxLen = 0;
      ctxLines = 0;
      while (dart.notNull(ctxLen) < 100 && dart.notNull(ctxEnd) < dart.notNull(source[dartx.length]) - 1) {
        ctxEnd = dart.notNull(ctxEnd) + 1;
        ctxLen = dart.notNull(ctxLen) + 1;
        if (source[dartx.get](dart.asInt(ctxEnd)) == "\n") {
          if ((ctxLines = dart.notNull(ctxLines) + 1) == 3) {
            break;
          }
        }
      }
      let context = dart.notNull(source[dartx.substring](dart.asInt(ctxStart), dart.asInt(this.location.offset))) + "[ERROR ->]" + dart.notNull(source[dartx.substring](dart.asInt(this.location.offset), dart.asInt(dart.notNull(ctxEnd) + 1)));
      return `${this.msg} ("${context}"): ${this.location}`;
    }
  }
  dart.setSignature(ParseError, {
    constructors: () => ({ParseError: [ParseError, [ParseLocation, core.String]]})
  });
  class ParseSourceSpan extends core.Object {
    ParseSourceSpan(start, end) {
      this.start = start;
      this.end = end;
    }
    toString() {
      return this.start.file.content[dartx.substring](dart.asInt(this.start.offset), dart.asInt(this.end.offset));
    }
  }
  dart.setSignature(ParseSourceSpan, {
    constructors: () => ({ParseSourceSpan: [ParseSourceSpan, [ParseLocation, ParseLocation]]})
  });
  // Exports:
  exports.ParseLocation = ParseLocation;
  exports.ParseSourceFile = ParseSourceFile;
  exports.ParseError = ParseError;
  exports.ParseSourceSpan = ParseSourceSpan;
});
//# sourceMappingURL=parse_util.js.map
